* NO_APP
RUNS_HUMAN_VERSION	equ	3
	.cpu 68000
	.include doscall.equ
* X68 GCC Develop

TAB	equ	$09
LF	equ	$0a
CR	equ	$0d

	.even
	.text

	.even
_GetInteger:
	move.l	d3,-(sp)
	move.l	4+4(sp),-(sp)	*_fp
	bra	SkipSpace
@@
	jbsr	_fgetc
	cmpi.b	#LF,d0
	beq	SkipSpace

	moveq.l	#-1,d1
	cmp.l	d1,d0		*EOF
	bne	@b
SkipSpace:
	jbsr	_fgetc
	cmpi.b	#' ',d0
	beq	SkipSpace

	cmpi.b	#TAB,d0
	beq	SkipSpace

	cmpi.b	#LF,d0
	beq	SkipSpace

	cmpi.b	#CR,d0
	beq	SkipSpace

	cmpi.b	#'#',d0
	beq	@b

	move.l	d0,-(sp)
	jbsr	_ungetc
	addq.w	#4,sp
	moveq.l	#0,d3		*Value = 0
gi_lp:
	jbsr	_fgetc
	subi.b	#'0',d0
	cmpi.b	#9,d0
	bhi	gi_end

	move.l	d3,d1
	asl.l	#2,d1		* *4
	add.l	d1,d3		* *5
	add.l	d3,d3		* *10
	add.l	d0,d3
	bra	gi_lp
gi_end:
	move.l	d3,d0
	addq.w	#4,sp
	move.l	(sp)+,d3
	rts

?C0:
	.dc.b 'rb',$00
?C1:
	.dc.b 'No such file',$00
?C2:
	.dc.b 'Is not ppm format',$00

	.even
	.globl _PPMLoad
_PPMLoad:
	link	a6,#-256
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5,-(sp)
	lea	_fp,a4
	tst.l	(a4)
	bne	@f

	pea	?C0(OPC)
	move.l	_File,-(sp)
	jbsr	_fopen
	move.l	d0,(a4)		*fp
	addq.w	#8,sp
	bne	@f

	pea	?C1(OPC)
	jbsr	_error
	addq.w	#4,sp
@@
	move.l	(a4),-(sp)
	jbsr	_fgetc
	cmpi.b	#'P',d0
	beq	?394
@@
	pea	?C2(OPC)
	jbsr	_error
	addq.w	#4,sp
?394:
	jbsr	_fgetc
	move.l	d0,d3
	cmpi.b	#'3',d3
	beq	?395

	cmpi.b	#'6',d3
	bne	@b
?395:
	bsr	_GetInteger
	move.l	d0,_Width
	bsr	_GetInteger
	move.l	d0,_Height
	bsr	_GetInteger
	move.l	d0,d5		*MaxColor
	cmp.w	#2,_OutBpp
	bne	fullcolor

	jbsr	_AllocateScreen
	bra	@f
fullcolor:
	jbsr	_AllocateScreen24
@@
	addq.l	#1,d5
	move.l	_Size,d4
	bge	@f

	addq.l	#1,d4
@@
	asr.l	#1,d4
	cmpi.b	#'3',d3
	bne	loadP6

	cmp.w	#2,_OutBpp
	bne	loadP3_24

	lea	_GetInteger,a3
loadP_16:
	lea	-256(a6),a5
	movea.l	a5,a0		*multbl
*init_multbl
	move.l	d5,d2		*MaxColor
	ble	@f

	moveq.l	#32,d1
	subq.w	#1,d2
	moveq.l	#0,d3
m_lp:
	move.l	d3,d0
	divu	d2,d0
	move.b	d0,(a0)+
	add.w	d1,d3
	dbra	d2,m_lp
@@
	move.l	_Screen,d6
	bra	@f
loadP_16lp:
	jbsr	(a3)
	move.b	(a5,d0.l),d5	*R
	jbsr	(a3)
	move.b	(a5,d0.l),d3	*G
	lsl.w	#5,d3
	or.b	d5,d3
	lsl.w	#5,d3
	jbsr	(a3)
	or.b	(a5,d0.l),d3	*B
	movea.l	d6,a0
	move.w	d3,(a0)+
	move.l	a0,d6
@@
	dbra	d4,loadP_16lp

	bra	?410
loadP3_24:
	move.l	d4,d0		*HalfSize
	add.l	d0,d0		* *2
	add.l	d0,d4		* *3
	movea.l	_Screen,a3
	bra	@f
P3_24lp:
	bsr	_GetInteger
	asl.w	#5,d0
	divu	d5,d0		* / MaxColor
	move.w	d0,(a3)+
@@
	dbra	d4,P3_24lp

	bra	?410
loadP6:
	cmp.w	#2,_OutBpp
	bne	loadP6_24

	cmp.l	#256,d5		*MaxColor
	bne	?412

	lea	_fgetc,a3
	move.l	_Screen,d6
	bra	?413
?416:
	jbsr	(a3)
	move.l	d0,d5		*R
	andi.w	#$f8,d5
	jbsr	(a3)
	move.l	d0,d3		*G
	andi.w	#$f8,d3
	lsl.w	#5,d3
	move.b	d5,d3
	add.w	d3,d3
	add.w	d3,d3
	jbsr	(a3)		*B
	lsr.b	#3,d0
	or.b	d0,d3
	movea.l	d6,a0
	move.w	d3,(a0)+
	move.l	a0,d6
?413:
	dbra	d4,?416

	bra	?410
?412:
	lea	_fgetc,a3
	bra	loadP_16
loadP6_24:
	move.l	d4,d0		*HalfSize
	add.l	d0,d0		* *2
	add.l	d4,d0		* *3
	move.l	d0,-(sp)
	pea	1.w
	move.l	_Screen,-(sp)
	jbsr	_fread
	lea	12(sp),sp
?410:
	move.l	_fp,d0
	cmp.l	#__iob,d0	*fp == stdin ?
	beq	@f

	jbsr	_fclose
@@
	move.l	#32768,_MaxColorGuaranteed
	cmp.w	#2,_OutBpp
	bne	@f

	move.w	#2,_InBpp
@@
	addq.w	#4,sp
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5
	unlk	a6
	rts

	.even
?C3:
	.dc.b	'wb',$00
?C4:
	.dc.b	'Cannot create',$00
?C5:
	.dc.b	'P6',$0a,'%d %d',$0a,'255',$0a,$00

	.even
	.globl	_PPMSave
_PPMSave:
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5/a6,-(sp)
	lea	_fp,a3
	tst.l	(a3)
	bne	@f		*fp == NULL ?

	pea	?C3(OPC)
	move.l	_File,-(sp)
	jbsr	_fopen
	move.l	d0,(a3)		*fp
	addq.w	#8,sp
	bne	@f

	pea	?C4(OPC)
	jbsr	_error
	addq.w	#4,sp
@@
	lea	_Width,a3
	lea	_Height,a4
	move.l	(a3),d0
	move.l	(a4),-(sp)
	move.l	d0,-(sp)
	jbsr	___mulsi3
	addq.w	#8,sp
	move.l	d0,d6		*HalfSize
	move.l	(a4),-(sp)
	move.l	(a3),-(sp)
	pea	?C5(OPC)
	move.l	_fp,-(sp)
	jbsr	_fprintf
	lea	16(sp),sp
	cmp.w	#1,_InBpp
	bne	?427
*SaveP6_Palet
	lea	_fputc,a3
	movea.l	_Screen,a4
	move.l	_fp,-(sp)
	move.l	#_Red,d5
	lea	_Green,a5
	lea	_Blue,a6
	subq.w	#4,sp
	bra	@f
?431:
	move.w	(a4)+,d3
	add.w	d3,d3
	movea.l	d5,a0
	move.w	(a0,d3.w),a1
	move.l	a1,(sp)
	jbsr	(a3)		*fputc
	move.w	(a5,d3.w),a1
	move.l	a1,(sp)
	jbsr	(a3)
	move.w	(a6,d3.w),a1
	move.l	a1,(sp)
	jbsr	(a3)
@@
	dbra	d6,?431

	addq.w	#8,sp
	bra	?432
?427:
	cmp.w	#2,_InBpp
	bne	saveP6_24
*SaveP6_16
	lea	_fputc,a3
	move.l	_fp,-(sp)
	subq.w	#4,sp
	movea.l	_Screen,a5
	bra	?434
?440:
*color extension (15bit -> 24bit)
	moveq.l	#0,d3
	move.w	(a5)+,d3
	moveq.l	#0,d0
	move.w	d3,d0
	lsr.w	#5,d0
	moveq.l	#28,d1		*%0001_11000
	and.b	d0,d1
	lsr.b	#2,d1		*upper 3bit
	lsl.w	#3,d0
	or.b	d1,d0		*Red
	move.l	d0,(sp)
	jbsr	(a3)

	moveq.l	#0,d0
	move.w	d3,d0
	moveq.l	#10,d1
	lsr.l	d1,d0
	moveq.l	#28,d1		*%0001_11000
	and.b	d0,d1
	lsr.b	#2,d1		*upper 3bit
	lsl.w	#3,d0
	or.b	d1,d0		*Green
	move.l	d0,(sp)
	jbsr	(a3)

	moveq.l	#0,d0
	move.w	d3,d0
	moveq.l	#28,d1		*%0001_11000
	and.b	d0,d1
	lsr.b	#2,d1		*upper 3bit
	lsl.w	#3,d0
	or.b	d1,d0		*Blue
	move.l	d0,(sp)
	jbsr	(a3)
?434:
	dbra	d6,?440

	addq.w	#8,sp
	bra	?432
saveP6_24:
	move.l	_fp,-(sp)
	move.l	d6,d0		*HalfSize
	add.l	d0,d0		* *2
	move.l	d6,d0		* *3
	move.l	d0,-(sp)
	pea	1.w
	move.l	_Screen,-(sp)
	jbsr	_fwrite
	lea	16(sp),sp
?432:
	moveq.l #36,d0
	add.l	#__iob,d0	*stdout
	move.l	_fp,d1
	cmp.l	d1,d0
	beq	@f

	move.l	d1,-(sp)
	jbsr	_fclose
	addq.w	#4,sp
@@
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5/a6
	rts
?C6:
	.dc.b	'Is not pbm format',$00

	.even
	.globl	_PBMLoad
_PBMLoad:
	movem.l	d4/d5/d6/a3/a4,-(sp)
	lea	_fp,a3
	tst.l	(a3)
	bne	@f

	pea	?C0(OPC)
	move.l	_File,-(sp)
	jbsr	_fopen
	move.l	d0,(a3)		*fp
	addq.w	#8,sp
	bne	@f

	pea	?C1(OPC)
	jbsr	_error
	addq.w	#4,sp
@@
	move.l	(a3),-(sp)
	jbsr	_fgetc
	cmpi.b	#'P',d0
	beq	?445
@@
	pea	?C6(OPC)
	jbsr	_error
	addq.w	#4,sp
?445:
	jbsr	_fgetc
	move.l	d0,d4
	cmpi.b	#'1',d4
	beq	?446

	cmpi.b	#'4',d4
	bne	@b
?446:
	lea	_GetInteger,a3
	jbsr	(a3)
	move.l	d0,_Width
	move.l	d0,d6
	jbsr	(a3)
	move.l	d0,_Height
	move.l	d0,d5
	jbsr	_AllocateScreen
	movea.l	_Screen,a4
	clr.w	d1
	cmpi.b	#'1',d4
	bne	loadP4

	move.l	_Size,d4
	bge	@f

	addq.l	#1,d4
@@
	asr.l	#1,d4		*HalfSize
	bra	loadP1_ent
loadP1_lp:
	jbsr	(a3)
	tst.l	d0
	sne	d1
	addq.w	#1,d1
	move.w	d1,(a4)+
loadP1_ent:
	dbra	d4,loadP1_lp

	bra	?457
loadP4:
	lea	_fgetc,a3
	bra	P4_yent
loadP4_xlp:
	jbsr	(a3)
	moveq.l	#8-1,d2
	cmp.l	d2,d4
	bgt	bitlp

	move.w	d4,d2
	subq.w	#1,d2
bitlp:
	add.b	d0,d0
	scs	d1
	addq.b	#1,d1
	move.w	d1,(a4)+
	dbra	d2,bitlp

	subq.l	#8,d4
P4_xent:
	bgt	loadP4_xlp
P4_yent:
	move.l	d6,d4		*Width
	dbra	d5,P4_xent

?457:
	move.l	(sp),d0
	cmp.l	#__iob,d0
	beq	@f

	jbsr	_fclose
@@
	move.l	#255,d0
	move.l	d0,_Red
	move.l	d0,_Green
	move.l	d0,_Blue
	moveq.l	#2,d0
	move.l	d0,_MaxColorGuaranteed
	addq.w	#4,sp
	movem.l	(sp)+,d4/d5/d6/a3/a4
	rts

	.even
	.end
